<!--
Copyright (C) 2018 Freetech Solutions

This file is part of OMniLeads

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see http://www.gnu.org/licenses/.

-->
{% extends "base.html" %}
{% load i18n %}
{% load static %}
{% block head_js %}
<script type="text/javascript" src="{% static 'ominicontacto/JS/csrf.js' %}"></script>
<script type="text/javascript" src="{% static 'reportes_app/JS/reportes_agentes_tiempos.js' %}"></script>

<style>
.modal-lg {
    max-width: 80% !important;
}
</style>

{% endblock %}
{% block content %}

<h1>{% trans 'Agentes' %}</h1>
<div id="wrapper-search">

    <button id="btnCollapse" class="btn btn-block" type="button" data-toggle="collapse" data-target="#wrapperSearchForm" aria-expanded="true" aria-controls="wrapperSearchForm"><span class="icon icon-search"></span>{% trans "Buscar" %}</button>

    <div id="wrapperSearchForm" class="show">

        <form role="form" method="post" enctype="multipart/form-data" >
            {% csrf_token %}
            {{ form.non_field_errors }}
            <div class="form-row">
                <div class="col-md-6">
                    <label for="{{ form.fecha.id_for_label }}">{% trans "Fecha" %}: </label>
                    {{form.fecha}}
                    {{ form.fecha.errors }}
                </div>
                <div class="col-md-6">
                    <label for="{{ form.agente.id_for_label }}">{% trans "Agente" %}: </label>
                      {{ form.agente }}
                      {{ form.agente.errors }}
                </div>
                <div class="col-md-6">
                    <label for="{{ form.todos_agentes.id_for_label }}">{% trans "Todos los agentes" %}: </label>
                      {{ form.todos_agentes }}
                      {{ form.todos_agentes.errors }}
                </div>
                <div class="col-md-6">
                    <label for="{{ form.agente.id_for_label }}">{% trans "Grupo de agentes" %}: </label>
                      {{ form.grupo_agente }}
                      {{ form.grupo_agente.errors }}
                </div>
            </div>

            <button type="submit" id="id_buscar_btn" class="btn btn-primary">
                {% trans "Buscar" %}
            </button>
        </form>
    </div>
</div>

{% if graficos_estadisticas  %}

<div>
    <h2>{% trans 'Período:' %} {{graficos_estadisticas.fecha_desde|date:"d/m/Y"}} - {{graficos_estadisticas.fecha_hasta|date:"d/m/Y"}}</h2>
    <hr>
    <div class="wrapper-table table-responsive">
        <button class="btn-collapse-table btn btn-light btn-sm" type="button" data-toggle="collapse" data-target=".multi-collapse-stats" aria-expanded="false">{% trans "Información completa" %}</button>
        <hr class="hr-space">
        <div class="wrapper-table table-responsive">
            <table class="table">
                <thead>
                    <tr>
                        <th>{% trans "Agente" %}</th>
                        <th>{% trans "Tiempo de session" %}</th>
                        <th>{% trans "Porcentaje en llamada" %}</th>
                        <th>{% trans "Llamadas procesadas" %}</th>
                        <th>{% trans "Tiempo promedio" %}</th>
                        <th>{% trans "Intentos fallidos" %}</th>
                    </tr>
                </thead>
                <tbody>
                    {% for agente in graficos_estadisticas.agentes_tiempos %}
                    <tr>
                        <td>{{agente.get_nombre_agente}}
                            <br>
                            <a href="#" role="button" class="tiemposAgenteModal" id_agente="{{agente.agente.id}}" data-toggle="modal" data-target="#reporteFechaModal"
                            fecha_desde="{{graficos_estadisticas.fecha_desde|date:'d/m/Y'}}" fecha_hasta="{{graficos_estadisticas.fecha_hasta|date:'d/m/Y'}}">
             {% trans "ver por fechas" %}</a>

                        </td>
                        <td>
                            {% if agente.get_string_tiempo_sesion %}
                                {{agente.get_string_tiempo_sesion}}{% trans 'hs' %}
                            {% else %}
                                0{% trans 'hs' %}
                            {% endif %}
                            <div class="collapse multi-collapse-stats">
                                <hr>
                                {% if agente.get_string_tiempo_pausa %}
                                    {{agente.get_string_tiempo_pausa}}{% trans 'hs' %}
                                {% else %}
                                    0{% trans 'hs' %}
                                {% endif %}
                                <span class="label">{% trans "pausa" %}</span>,
                                {{agente.get_string_tiempo_llamada}}{% trans 'hs' %}
                                <span class="label">{% trans "llamada" %}</span>
                            </div>
                        </td>
                        <td>
                            {% if agente.tiempo_porcentaje_llamada %}
                                {{agente.tiempo_porcentaje_llamada|floatformat:2}}%
                            {% else %}
                                0%
                            {% endif %}
                            <div class="collapse multi-collapse-stats">
                            <hr>
                            <span>
                            {% if agente.tiempo_porcentaje_pausa %}
                                {{agente.tiempo_porcentaje_pausa|floatformat:2}}%
                            {% else %}
                                0%
                            {% endif %}
                            <span class="label">{% trans "pausa" %}</span>,
                            {% if agente.tiempo_porcentaje_wait %}
                                {{agente.tiempo_porcentaje_wait|floatformat:2}}%
                            {% else %}
                                0%
                            {% endif %}
                            <span class="label">{% trans "espera" %}</span>
                            </span>
                            </div>
                        </td>
                        <td>{{agente.cantidad_llamadas_procesadas}}</td>
                        <td>{{agente.tiempo_promedio_llamadas|default_if_none:0}}{% trans 's' %}</td>
                        <td>{{agente.cantidad_intentos_fallidos}}</td>
                    </tr>
                    {% endfor %}
                </tbody>
            </table>
        </div>
    </div>
    <a class="btn btn-outline-primary" target="_blank" href="{% url 'reportes_agentes_exporta' tipo_reporte='tiempos_agentes' %}">{% trans "Exportar reporte de tiempos(CSV)" %}</a>
</div>
<hr>
<div>
    <div class="wrapper-table table-responsive">
        <table class="table">
            <thead>
                <tr>
                    <th>{% trans "Agente" %}</th>
                    <th>{% trans "Pausa" %}</th>
                    <th>{% trans "Tipo" %}</th>
                    <th>{% trans "Tiempo" %}</th>
                </tr>
            </thead>
            {% for agente in graficos_estadisticas.agente_pausa %}
                <tr>
                    <td>{{agente.nombre_agente}}
                        <a href="#" role="button" class="tiemposPausaModal" id_agente="{{agente.id}}" data-toggle="modal" data-target="#reportePausaModal"
                        fecha_desde="{{graficos_estadisticas.fecha_desde|date:'d/m/Y'}}" fecha_hasta="{{graficos_estadisticas.fecha_hasta|date:'d/m/Y'}}"
                        pausa_id="{{agente.pausa_id}}">
                        {% trans "ver por fechas" %}</a>
                    </td>
                    <td>{{agente.pausa}}</td>
                    <td>{{agente.tipo_de_pausa}}</td>
                    <td>{{agente.tiempo}}{% trans 'hs' %}</td>
                </tr>
            {% endfor %}
            <tbody>

            </tbody>
        </table>
    </div>
    <a class="btn btn-outline-primary" target="_blank" href="{% url 'reportes_agentes_exporta' tipo_reporte='pausas_agentes' %}">{% trans "Exportar reporte de pausas(CSV)" %}</a>
</div>
<hr>
<div>
    <div class="wrapper-table table-tall table-responsive">
        <table class="table">
            <thead>
                <tr>
                    <th>{% trans "Agente" %}</th>
                    <th>{% trans "Cola" %}</th>
                    <th>{% trans "Tiempo de llamadas" %}</th>
                    <th>{% trans "Llamadas procesadas" %}</th>

                </tr>
            </thead>
            {% for agente in graficos_estadisticas.count_llamada_campana %}
                <tr>
                    <td>{{agente.0}}</td>
                    <td>{{agente.1}}</td>
                    <td>{{agente.2}}{% trans 'hs' %}</td>
                    <td>{{agente.3}}</td>

                </tr>
            {% endfor %}
            <tbody>

            </tbody>
        </table>
    </div>
    <a class="btn btn-outline-primary" target="_blank" href="{% url 'reportes_agentes_exporta' tipo_reporte='llamadas_agentes' %}">{% trans "Exportar reporte cantidad llamadas(CSV)" %}</a>
</div>
<hr>
<div>
    <h2>{% trans "Cantidad de llamadas por agente" %}</h2>
    <br>
    <div class="wrapper-table table-tall table-responsive">
        <table class="table">
            <thead>
            <tr>
                <th>{% trans "Agente" %}</th>
                <th>{% trans "Total" %}</th>
                <th>{% trans "PREVIEW" %}</th>
                <th>{% trans "DIALER" %}</th>
                <th>{% trans "INBOUND" %}</th>
                <th>{% trans "MANUAL" %}</th>
                <th>{% trans "TRANSFERIDAS" %}</th>
            </tr>
            </thead>
            <tbody>
                {% for agente, total_campana, total_preview, total_dialer, total_inbound, total_manual, total_transferidas in graficos_estadisticas.dict_agente_counter %}
                    <tr>
                        <td>{{ agente }}</td>
                        <td>{{ total_campana }}</td>
                        <td>{{ total_preview }}</td>
                        <td>{{ total_dialer }}</td>
                        <td>{{ total_inbound }}</td>
                        <td>{{ total_manual }}</td>
                        <td>{{ total_transferidas }}</td>
                    </tr>
                {% endfor %}
            </tbody>
        </table>
    </div>
    <div class="col-lg-6">
        <h3>{% trans 'Cantidad de llamadas de los agentes por tipo de llamadas' %}</h3>
        <div class="graficos-avances col-md-auto">
            <figure>
                {{ graficos_estadisticas.barra_agente_total.render_unicode|safe }}
            </figure>
        </div>
    </div>

    <a class="btn btn-outline-primary" target="_blank" href="{% url 'reportes_agentes_exporta' tipo_reporte='llamadas_tipo_agentes' %}">{% trans "Exportar reporte de tipo de llamadas(CSV)" %}</a>

</div>

<!-- Modal -->
<div class="modal fade" id="reporteFechaModal" tabindex="-1" role="dialog" aria-labelledby="reporteFechaModalLabel" aria-hidden="true">
  <div class="modal-dialog modal-lg" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h1 class="modal-title" id="reporteFechaModalLabel">{% trans "Agente" %} <strong id="nombre_agente"></strong></h1>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
            <div id="error"></div>
            <div class="table-responsive">
                <table class="table">
                    <tr>
                        <td>{% trans "Fecha" %}</td>
                        <td>{% trans "Sesión" %}</td>
                        <td>{% trans "Pausa" %}</td>
                        <td>{% trans "Llamada" %}</td>
                        <td>{% trans "% En llamada" %}</td>
                        <td>{% trans "% En pausa" %}</td>
                        <td>{% trans "% En espera" %}</td>
                        <td>{% trans "Llamadas procesadas" %}</td>
                        <td>{% trans "Tiempo promedio" %}</td>
                        <td>{% trans "Intentos fallidos" %}</td>
                    </tr>
                    <tbody id="output">
                    </tbody>
                </table>
            </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">{% trans "Cerrar" %}</button>
      </div>
    </div>
  </div>
</div>

<div class="modal fade" id="reportePausaModal" tabindex="-1" role="dialog" aria-labelledby="reportePausaModalLabel" aria-hidden="true">
  <div class="modal-dialog modal-lg" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h1 class="modal-title" id="reportePausaModalLabel">{% trans "Agente" %} <strong id="nombre_agente_pausa"></strong> {% trans "para la pausa" %} <strong id="nombre_pausa"></strong></h1>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
            <div class="table-responsive">
                <table class="table">
                    <tr>
                        <td>{% trans "Fecha" %}</td>
                        <td>{% trans "Tiempo" %}</td>
                    </tr>
                    <tbody id="output_pausa">
                    </tbody>
                </table>
            </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">{% trans "Cerrar" %}</button>
      </div>
    </div>
  </div>
</div>
{% endif %}
{% endblock %}
